% mat1401DAC

% demonstrates output to DAC0, 40 kHz clock
% can check data in 1401 using Interact
% output to DAC0, uses MEMDAC

% jgc 3.02.10

U14TYPEPOWER=3;  % Power1401  
dacScale=32768/5; % scale for Volts
res=MATCED32('cedOpenX',0);  % v3+ can specify 1401
if (res < 0)
   disp(['1401 not opened, error number ' int2str(res)]);
   return;
end %opened OK if we continue  
typeOf1401=MATCED32('cedTypeOf1401');  % see below
res=MATCED32('cedResetX');
res=0;
% uncomment this next line, if you get a -544 error later
% res=MATCED32('cedWorkingSet',400,4000);
if (res > 0)
    disp('error with call to cedWorkingSet - try commenting it out');
    return
end    
% next line needs v3 or later of matced32.dll
MATCED32('cedLdX','C:\1401Lang\','MEMDAC');
freq=input('Frequency(Hz)? ');
amp=input('Peak amplitude(V)? ');
scaleAmp=dacScale*amp;
durn=input('Duration(ms)? ');
daclength=40*durn; % 40 kHz
z=1:daclength;  
dacOut=scaleAmp*sin(2*pi*freq*z/40000);
MATCED32('cedTo1401',daclength,0,dacOut);
sz=int2str(2*daclength);
MATCED32('cedSendString','CLEAR;');
ktrig=input('Await trigger pulse (y=yes)? ','s');
% just use DAC0
if ktrig =='y'
   disp('Waiting for trigger (on E3 input)');
   MATCED32('cedSendString',['MEMDAC,I,2,0,' sz ',0,1,HT,10,10;']);
else % default option
   MATCED32('cedSendString',['MEMDAC,I,2,0,' sz ',0,1,H,10,10;']);
end   
res=MATCED32('cedCloseX');